<template>
  <div class="form-container flex flex-col gap-2">
    <FloatLabel
      class="form-float"
      :class="{
        'w-full': wFull
      }"
    >
      <AutoComplete
        v-model="value"
        v-bind="$attrs"
        :name="name"
        :rules="rules"
        :invalid="invalid"
        class="form-input"
        :class="{
          'form-input--password': type === 'password',
          'w-full': wFull
        }"
      />
      <label v-if="label" :for="attrs.id"> {{ label }} </label>
    </FloatLabel>
    <small v-if="errorMessage" class="color-danger"> {{ errorMessage }} </small>
    <small v-if="small"> {{ small }} </small>
  </div>
</template>

<script lang="ts" setup>
import AutoComplete from 'primevue/autocomplete'

const attrs = useAttrs() as any
const emit = defineEmits(['update:modelValue'])

const props = defineProps({
  modelValue: {
    type: null as unknown as PropType<string[] | null>,
    required: false,
    default: ''
  },
  label: {
    type: String,
    required: false
  },
  name: {
    type: String,
    required: true
  },
  rules: {
    type: String,
    required: false,
    default: ''
  },
  type: {
    type: String,
    required: false
  },
  small: {
    type: String,
    required: false
  },
  float: {
    type: Boolean,
    required: false
  },
  wFull: {
    type: Boolean,
    required: false
  }
})

const invalid = computed(() => (errorMessage.value ? true : false))

const { value, errorMessage } = useField(props.name, props.rules, {
  initialValue: props.modelValue,
  syncVModel: true
})
</script>

<style lang="scss" scoped></style>
